PKIArchiveControl (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.cert.crmf

## Class PKIArchiveControl

- java.lang.Object
- - org.bouncycastle.cert.crmf.PKIArchiveControl

- All Implemented Interfaces:
    Control

      public class PKIArchiveControl
      extends java.lang.Object
      implements Control

  Carrier for a PKIArchiveOptions structure.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `archiveRemGenPrivKey`
    `static int` | `encryptedPrivKey`
    `static int` | `keyGenParameters`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PKIArchiveControl(org.bouncycastle.asn1.crmf.PKIArchiveOptions pkiArchiveOptions)` Basic constructor - build from an PKIArchiveOptions structure.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getArchiveType()` Return the archive control type, one of: encryptedPrivKey,keyGenParameters,or archiveRemGenPrivKey.
    `CMSEnvelopedData` | `getEnvelopedData()` Return the enveloped data structure contained in this control.
    `org.bouncycastle.asn1.ASN1ObjectIdentifier` | `getType()` Return the type of this control.
    `org.bouncycastle.asn1.ASN1Encodable` | `getValue()` Return the underlying ASN.1 object.
    `boolean` | `isEnvelopedData()` Return whether this control contains enveloped data.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### encryptedPrivKey

          public static final int encryptedPrivKey

      See Also:
        Constant Field Values

    - #### keyGenParameters

          public static final int keyGenParameters

      See Also:
        Constant Field Values

    - #### archiveRemGenPrivKey

          public static final int archiveRemGenPrivKey

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PKIArchiveControl

          public PKIArchiveControl(org.bouncycastle.asn1.crmf.PKIArchiveOptions pkiArchiveOptions)

      Basic constructor - build from an PKIArchiveOptions structure.
      Parameters:
        `pkiArchiveOptions` - the ASN.1 structure that will underlie this control.

  - ### Method Detail

    - #### getType

          public org.bouncycastle.asn1.ASN1ObjectIdentifier getType()

      Return the type of this control.
      Specified by:
        `getType` in interface `Control`
      Returns:
        CRMFObjectIdentifiers.id_regCtrl_pkiArchiveOptions

    - #### getValue

          public org.bouncycastle.asn1.ASN1Encodable getValue()

      Return the underlying ASN.1 object.
      Specified by:
        `getValue` in interface `Control`
      Returns:
        a PKIArchiveOptions structure.

    - #### getArchiveType

          public int getArchiveType()

      Return the archive control type, one of: encryptedPrivKey,keyGenParameters,or archiveRemGenPrivKey.
      Returns:
        the archive control type.

    - #### isEnvelopedData

          public boolean isEnvelopedData()

      Return whether this control contains enveloped data.
      Returns:
        true if the control contains enveloped data, false otherwise.

    - #### getEnvelopedData

          public CMSEnvelopedData getEnvelopedData()
                                            throws CRMFException

      Return the enveloped data structure contained in this control.
      Returns:
        a CMSEnvelopedData object.
      Throws:
        `CRMFException`